package mps.forum.myxml.generator.baseLanguage.template.main;

import jetbrains.mps.smodel.SNode;
import jetbrains.mps.smodel.SModelUtil;
import jetbrains.mps.generator.template.ITemplateGenerator;
import jetbrains.mps.generator.template.INodeBuilder;
import jetbrains.mps.bootstrap.structureLanguage.PropertyDeclaration;
import jetbrains.mps.bootstrap.structureLanguage.LinkDeclaration;
import jetbrains.mps.util.CollectionUtil;

import java.util.List;
import java.util.Iterator;

import mps.forum.myxml.Document;
import mps.forum.myxml.Element;

/**
 * Igor Alshannikov
 * Date: Dec 11, 2006
 */
public class Queries {
    public static List<Document> templateMappingRule_SourceQuery_Document(ITemplateGenerator generator) {
        return SModelUtil.allNodes(generator.getSourceModel(), Document.class);
    }

    public static String propertyMacro_Document_className(SNode sourceNode, SNode templateNode, PropertyDeclaration property, ITemplateGenerator generator) {
        return sourceNode.getName();
    }

    public static SNode templateSourceNodeQuery_Document_rootElement(SNode parentSourceNode, ITemplateGenerator generator) {
        Document document = (Document) parentSourceNode;
        return document.getRootElement();
    }

    public static String propertyMacro_Element_name(SNode sourceNode, SNode templateNode, PropertyDeclaration property, ITemplateGenerator generator) {
        return sourceNode.getName();
    }


    public static List<Element> templateSourceQuery_Element_contentElements(SNode parentSourceNode, ITemplateGenerator generator) {
        Element element = (Element) parentSourceNode;
        return CollectionUtil.iteratorAsList(element.contents());
    }

    public static boolean reductionRuleCondition_Element(SNode sourceNode, ITemplateGenerator generator) {
        return sourceNode instanceof Element;
    }

    public static SNode referenceMacro_enclosingDocument_generatedClass(SNode sourceNode, SNode templateNode, LinkDeclaration link, ITemplateGenerator generator) {
        Document document = SModelUtil.findParent(sourceNode, Document.class);
        INodeBuilder classBuilder = generator.findNodeBuilderForSource(document, "generatedClass");
        return classBuilder.getTargetNode();
    }
}
